/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved.
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.geometries.viewer3d.controls.light_editor;

import java.awt.Color;
import java.util.ArrayList;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import org.visnow.vn.geometries.viewer3d.lights.DirectionalLightObject;
import org.visnow.vn.geometries.viewer3d.lights.LightObject;
import org.visnow.vn.gui.icons.IconsContainer;

/**
 *
 ** @author Krzysztof S. Nowinski, University of Warsaw ICM
 */
public class SingleLightEditor extends javax.swing.JPanel
{

    private LightObject lightObject = null;
    private LightsEditor parentPanel = null;

    /**
     * Creates new form DirectionalLightEditor
     */
    public SingleLightEditor()
    {
        initComponents();
        lightTypeButton.setIcons(
            new Icon[]{new ImageIcon(IconsContainer.getBallBlack()),
                       new ImageIcon(IconsContainer.getBallBlue1())});
    }

    /**
     * Creates new form DirectionalLightEditor
     */
    public SingleLightEditor(LightObject lightObject, LightsEditor parentPanel)
    {
        initComponents();
        lightTypeButton.setIcons(
            new Icon[]{new ImageIcon(IconsContainer.getBallBlack()),
                       new ImageIcon(IconsContainer.getBallBlue1())});
        setLightObject(lightObject);
        this.parentPanel = parentPanel;
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        resetButton = new javax.swing.JButton();
        lightTypeButton = new org.visnow.vn.gui.widgets.MultistateButton();
        editButton = new javax.swing.JToggleButton();
        colorPanel = new javax.swing.JPanel();

        setMinimumSize(new java.awt.Dimension(180, 24));
        setPreferredSize(new java.awt.Dimension(220, 24));
        setLayout(new java.awt.GridBagLayout());

        resetButton.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        resetButton.setText("reset");
        resetButton.setBorder(null);
        resetButton.setMargin(new java.awt.Insets(2, 2, 2, 2));
        resetButton.setMaximumSize(new java.awt.Dimension(60, 26));
        resetButton.setMinimumSize(new java.awt.Dimension(61, 26));
        resetButton.setName("resetButton"); // NOI18N
        resetButton.setPreferredSize(new java.awt.Dimension(61, 26));
        resetButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                resetButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        add(resetButton, gridBagConstraints);

        lightTypeButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));
        lightTypeButton.setText("multistateButton1");
        lightTypeButton.setMaximumSize(new java.awt.Dimension(26, 26));
        lightTypeButton.setMinimumSize(new java.awt.Dimension(26, 26));
        lightTypeButton.setName("lightTypeButton"); // NOI18N
        lightTypeButton.setPreferredSize(new java.awt.Dimension(26, 26));
        lightTypeButton.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                lightTypeButtonStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(lightTypeButton, gridBagConstraints);

        editButton.setText("Edit");
        editButton.setMaximumSize(new java.awt.Dimension(70, 26));
        editButton.setMinimumSize(new java.awt.Dimension(70, 26));
        editButton.setName("editButton"); // NOI18N
        editButton.setPreferredSize(new java.awt.Dimension(70, 26));
        editButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                editButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_END;
        add(editButton, gridBagConstraints);

        colorPanel.setBackground(new java.awt.Color(204, 204, 204));
        colorPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        colorPanel.setMinimumSize(new java.awt.Dimension(26, 18));
        colorPanel.setName("colorPanel"); // NOI18N
        colorPanel.setPreferredSize(new java.awt.Dimension(100, 18));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(8, 8, 8, 8);
        add(colorPanel, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    public boolean isSelected()
    {
        return editButton.isSelected();
    }

    private void lightTypeButtonStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_lightTypeButtonStateChanged
    {//GEN-HEADEREND:event_lightTypeButtonStateChanged
        int state = lightTypeButton.getState();
        if (lightObject != null)
            lightObject.setState(state);
        editButton.setEnabled(state != 0);
        resetButton.setEnabled(state != 0);
    }//GEN-LAST:event_lightTypeButtonStateChanged

    private void editButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_editButtonActionPerformed
    {//GEN-HEADEREND:event_editButtonActionPerformed
        parentPanel.setEdit(this);
    }//GEN-LAST:event_editButtonActionPerformed

    private void resetButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_resetButtonActionPerformed
    {//GEN-HEADEREND:event_resetButtonActionPerformed
        if (lightObject != null)
            lightObject.reset();
        updateColor();
    }//GEN-LAST:event_resetButtonActionPerformed

    public void setParentPanel(LightsEditor parentPanel)
    {
        this.parentPanel = parentPanel;
    }

    public LightObject getLightObject()
    {
        return lightObject;
    }

    public void setLightObject(LightObject lightObject)
    {
        this.lightObject = lightObject;
        colorPanel.setBackground(BrightColor.bright(lightObject.getLightColor()));
        if (lightObject instanceof DirectionalLightObject)
            lightTypeButton.setIcons(
                new Icon[]{new ImageIcon(IconsContainer.getBallBlack()),
                           new ImageIcon(IconsContainer.getBallBlue1()),
                           new ImageIcon(IconsContainer.getBallBlue2())});
        lightTypeButton.setState(lightObject.getState());
    }

    public void updateColor(Color color)
    {
        colorPanel.setBackground(color);
    }

    public void updateColor()
    {
        colorPanel.setBackground(BrightColor.bright(lightObject.getLightColor()));
    }

    public void cleanEdit()
    {
        editButton.setSelected(false);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JPanel colorPanel;
    protected javax.swing.JToggleButton editButton;
    protected org.visnow.vn.gui.widgets.MultistateButton lightTypeButton;
    protected javax.swing.JButton resetButton;
    // End of variables declaration//GEN-END:variables


}
